#! /usr/bin/perl

$outpath = "/tmp";
$m2b_path = "."; # Pfad zum marks2bytepos-Skript

if ($#ARGV != 0)
{
	print "Syntax: $0 pfad\n";
	exit (1);
}

($path) = @ARGV;
-d $path || die "$path ist ungültig.\n";

($startpos, $endpos) = `$m2b_path/marks2bytepos.pl $path`;

$startpos =~ /^\d+$/ || die "Startposition ist ungültig.\n";
$endpos =~ /^\d+$/ || die "Endposition ist ungültig.\n";
!(-f "$outpath/temp.vdr") || die "temp.vdr existiert bereits.\n";

$buffersize = 16777216; # 16 MB
#$buffersize = 33554432; # 32 MB
$glength = $endpos - $startpos;
$glength > 0 || die "startpos >= endpos\n";

$path =~ s/\/$//; # Slash am Pfadende entfernen falls vorhanden

opendir(DIR, $path);
@DIR = readdir(DIR);
closedir(DIR);
@DIR = sort @DIR;

@size = (); # enthält die Dateigrößen der einzelnen vdr-Videodateien
$size = 0; # Größe der aktuellen Datei
$sizeprev = 0; # Größe der verhergehenden Datei
$gsize = 0; # Gesamtgröße bis zur aktuellen Datei (aufsummiert)
$sf = 0; # Datei, in welcher der Schnitt anfängt
$ef = 0; # Datei, in der der Schnitt aufhört
$sfpos = $startpos; # Byteposition in der Startdatei
$efpos = $endpos; # Byteposition in der Enddatei
@stat = (); # um temporär die Dateiinformationen auszulesen

# Verzeichnis durchsuchen und die ???.vdr Videodateien ermitteln und Größe bestimmen
for ($i = 0; $i <= $#DIR; $i++)
{
	if (!($DIR[$i] =~ /^\d{3}\.vdr$/))
	{
		# Einträge, die keine Videodateien sind rausschmeißen
		splice (@DIR, $i, 1);
		$i--;
	}
	else
	{
		# Dateigröße bestimmen
		$sizeprev = $size; # Größe der vorherigen Datei merken
		@stat = stat ("$path/$DIR[$i]");
		$size = $stat[7];
		push (@size, $size);

		# Gesamtgröße nach jeder Datei
		$gsize += $size;

		# Start- und Enddatei und die jeweiligen Start- u. Endpunkte darin bestimmen
		if ($startpos >= $gsize)
		{
			$sf = $i+1;      # Startfile setzen; $i+1 ex., da oben geprüft, daß $endpos - $startpos > 0
			$sfpos -= $size; # Anfangsposition im Startfile
		}
	
		if (($endpos > ($gsize - $size)) && ($endpos <= $gsize))
		{
			$ef = $i; # Endfile setzen
			$efpos = $size - ($gsize - $endpos); # Endposition im Endfile
		}
	}
}

# Endpositon liegt außerhalb des Datenbereiches -> wird aufs Datenende gesetzt
# (falls man die marks.vdr per Hand erstellt und die Endmarke außerhalb liegen sollte)
if ($endpos > $gsize)
{
	$endpos = $gsize;
	$efpos = $size;
	$ef = $i;
}


$gpos = $startpos;
$buffer = "";
open (OUT, ">$outpath/temp.vdr") || die "Kann temp.vdr nicht öffnen.\n";
binmode(OUT);
for ($i = $sf; $i <= $ef; $i++)
{
	open (IN, "<$path/$DIR[$i]") || die "Kann $path/$DIR[$i] nicht öffnen.\n";
	binmode(IN);

	if ($i == $sf)
	{
		$pos1 = $sfpos;
		$pos2 = $sf == $ef ? $efpos : $size[$i]; # falls Anfang und Ende in derselben Datei liegen
	}
	elsif ($i == $ef)
	{
		$pos1 = $sf == $ef ? $sfpos : 0; # falls Anfang und Ende in derselben Datei liegen
		$pos2 = $efpos;
	}
	else
	{
		$pos1 = 0;
		$pos2 = $size[$i];
	}

	$length = $pos2 - $pos1;
	$rest = $length % $buffersize;
	
	$pos = $pos1;
	sysseek (IN, $pos1, 0);
	while ($pos + $buffersize <= $pos2)
	{
		sysread (IN, $buffer, $buffersize);
		syswrite (OUT, $buffer, $buffersize);
		$pos += $buffersize;
		$gpos += $buffersize;

		$gproz = ($gpos - $startpos) * 100 / $glength;
		$proz = ($pos - $pos1) * 100 / $length;
		printf ("%s: %10.0f %6.2f%% | %10.0f %6.2f%%\n", $DIR[$i], $pos, $proz, $gpos, $gproz);
	}

	if ($rest > 0)
	{
		sysread (IN, $buffer, $rest);
		syswrite (OUT, $buffer, $rest);
		$pos += $rest;
		$gpos += $rest;

		$gproz = ($gpos - $startpos) * 100 / $glength;
		$proz = ($pos - $pos1) * 100 / $length;
		printf ("%s: %10.0f %6.2f%% | %10.0f %6.2f%%\n", $DIR[$i], $pos, $proz, $gpos, $gproz);
	}

	close (IN);
}

close (OUT);



